
dosseg
.model LARGE;
.stack 200h
.data
	CurX dw ?
.code
.386
public _VgaC_BitmapBoundsAsm,_VgaC_BitmapAsm,_CopyVirToScrAsm

pBmpOutInfo equ [bp+24]
pBitmap     equ [bp+20]

_VgaC_BitmapBoundsAsm proc
	 pusha
	 mov bp,sp;
	 les di,pBmpOutInfo;
	 mov bx,word ptr [es:di + 2];
	 mov ax,bx;
	 mov dx,320;
	 mul dx;
	 mov cx,word ptr [es:di];
	 add ax,cx
	 les di,_libVirScreen
	 add di,ax
	 lfs si,pBitmap
	 mov ax,[fs:si]
	 add ax,cx
	 dec ax
	 mov dx,[fs:si + 2];
	 add dx,bx;
	 dec dx;
	 lfs si,dword ptr [fs:si + 4];
	 mov bp,ax
	 mov CurX,cx
F1_NEXT_2:
	 mov al, [fs:si]
	 cmp al,0
	 je NOF1_DRAW
	 cmp cx,320
	 jge NOF1_DRAW
	 cmp cx,0
	 jl NOF1_DRAW
	 cmp bx,200
	 jge NOF1_DRAW
	 cmp bx,0
	 jl NOF1_DRAW
F1_DRAW:
	 mov [es:di],al
NOF1_DRAW:
	 inc si;
	 inc di;
	 inc cx;
	 cmp bp,cx;
	 jge F1_NEXT_2;
	 add di,319;
	 mov cx,CurX
	 add di,cx;
	 sub di,bp;
	 inc bx;
	 cmp bx,dx;
	 jle F1_NEXT_2;
	 popa;
	 ret;
_VgaC_BitmapBoundsAsm endp

_VgaC_BitmapAsm proc
	 pusha;
	 mov bp,sp;
	 les di,pBmpOutInfo;
	 mov ax,word ptr [es:di + 2];
	 mov dx,320;
	 mul dx;
	 add ax,word ptr [es:di];
	 les di,_libVirScreen;
	 add di,ax;
	 lfs si,pBitmap;
	 mov bx,[fs:si];
	 mov dx,[fs:si + 2];
	 lfs si,dword ptr [fs:si + 4];
F2_NEXT_1:
	 mov cx,bx;
F2_NEXT_2:
	 mov al,[fs:si];
	 cmp al,0;
	 je NOF2_DRAW;
F2_DRAW:
	 mov [es:di],al;
NOF2_DRAW:
	 inc si;
	 inc di;
	 dec cx;
	 jnz F2_NEXT_2;
	 add di,320;
	 sub di,bx;
	 dec dx;
	 jnz F2_NEXT_1;
	 popa
	 ret
_VgaC_BitmapAsm endp

_CopyVirToScrAsm proc
	push ds
	lds si,_libVirScreen;
	mov di,0A000h;
	mov es,di;
	xor di,di;
	mov cx,16000;
	cld;
	rep movsd;
	pop ds
	ret
_CopyVirToScrAsm endp

end