/*
뢮 ࠩ⮢  ࠡ⪠ ஢...
*/
#include "qgspr.h"
#include <stdio.h>

void VgaBitmap(PBITMAP pBitmap,
						PBMPOUTINFO pBmpOutInfo)
{
   asm les di,pBmpOutInfo;
   asm mov ax,word ptr [es:di + 2];
   asm mov dx,320;
   asm mul dx;
   asm add ax,word ptr [es:di];
   asm les di,libVirScreen;
   asm add di,ax;
   asm push ds;
   asm lds si,pBitmap;
   asm mov bx,[ds:si];
   asm mov dx,[ds:si + 2];
   asm lds si,dword ptr [ds:si + 4];
   asm cld;

DRAW:
   asm mov cx,bx;
   asm rep movsb;
   asm add di,320;
   asm sub di,bx;
   asm dec dx;
   asm jnz DRAW;
   asm pop ds;

}

void VgaC_Bitmap(PBITMAP pBitmap,
						PBMPOUTINFO pBmpOutInfo)
{
	asm les di,pBmpOutInfo;
	asm mov ax,word ptr [es:di + 2];
	asm mov dx,320;
	asm mul dx;
	asm add ax,word ptr [es:di];
	asm les di,libVirScreen;
	asm add di,ax;
	asm push ds;
	asm lds si,pBitmap;
	asm mov bx,[ds:si];
	asm mov dx,[ds:si + 2];
	asm lds si,dword ptr [ds:si + 4];
NEXT_1:
	asm mov cx,bx;
NEXT_2:
	asm mov al,[ds:si];
	asm cmp al,0;
	asm je NODRAW;
DRAW:
	asm mov [es:di],al;
NODRAW:
	asm inc si;
	asm inc di;
	asm dec cx;
	asm jnz NEXT_2;
	asm add di,320;
	asm sub di,bx;
	asm dec dx;
	asm jnz NEXT_1;
	asm pop ds;

}

void VgaBitmapBounds(PBITMAP pBitmap,
						PBMPOUTINFO pBmpOutInfo)
{
	asm les di,pBmpOutInfo;
	asm mov bx,word ptr [es:di + 2];
	asm mov ax,bx;
	asm mov dx,320;
	asm mul dx;
	asm mov cx,word ptr [es:di];
	asm add ax,cx;
	asm les di,libVirScreen;
	asm add di,ax;
	asm push ds;
	asm lds si,pBitmap;
	asm mov ax,[ds:si];
	asm add ax,cx;
	asm dec ax;
	asm mov dx,[ds:si + 2];
	asm inc bx
	asm add dx,bx;
	asm dec dx;
	asm lds si,dword ptr [ds:si + 4];
	asm push cx;
	asm cld;
NEXT_2:
	asm cmp cx,320;
	asm jge NODRAW;
	asm cmp cx,0;
	asm jl NODRAW;
	asm cmp bx,200;
	asm jge NODRAW;
	asm cmp bx,0;
	asm jl NODRAW;
DRAW:
	asm movsb
	asm dec si
	asm dec di
NODRAW:
	asm inc si;
	asm inc di;
	asm inc cx;
	asm cmp ax,cx;
	asm jge NEXT_2;
	asm pop cx;
	asm push cx;
	asm add di,319;
	asm add di,cx;
	asm sub di,ax;
	asm inc bx;
	asm cmp bx,dx;
	asm jle NEXT_2;
	asm pop cx;
	asm pop ds;
}

void VgaC_BitmapBounds(PBITMAP pBitmap,
						PBMPOUTINFO pBmpOutInfo)
{
	asm les di,pBmpOutInfo;
	asm mov bx,word ptr [es:di + 2];
	asm mov ax,bx;
	asm mov dx,320;
	asm mul dx;
	asm mov cx,word ptr [es:di];
	asm add ax,cx;
	asm les di,libVirScreen;
	asm add di,ax;
	asm push ds;
	asm lds si,pBitmap;
	asm mov ax,[ds:si];
	asm add ax,cx;
	asm dec ax;
	asm mov dx,[ds:si + 2];
	asm add dx,bx;
	asm dec dx;
	asm lds si,dword ptr [ds:si + 4];
	asm push bp;
	asm push cx;
NEXT_2:
	asm mov bp,[ds:si];
	asm and bp,0xFF;
	asm cmp bp,0;
	asm je NODRAW;
	asm cmp cx,320;
	asm jge NODRAW;
	asm cmp cx,0;
	asm jl NODRAW;
	asm cmp bx,200;
	asm jge NODRAW;
	asm cmp bx,0;
	asm jl NODRAW;
DRAW:
	asm xchg ax,bp
	asm mov [es:di],al
	asm xchg ax,bp
NODRAW:
	asm inc si;
	asm inc di;
	asm inc cx;
	asm cmp ax,cx;
	asm jge NEXT_2;
	asm pop cx;
	asm push cx;
	asm add di,319;
	asm add di,cx;
	asm sub di,ax;
	asm inc bx;
	asm cmp bx,dx;
	asm jle NEXT_2;
	asm pop cx;
	asm pop bp;
	asm pop ds;
}






void MonoBitmap(PBITMAP pBitmap,
						PBMPOUTINFO pBmpOutInfo,BYTE bColor)
{
	asm les di,pBmpOutInfo;
	asm mov ax,word ptr [es:di + 2];
	asm mov dx,320;
	asm mul dx;
	asm add ax,word ptr [es:di];
	asm les di,libVirScreen;
	asm add di,ax;
	asm mov bl,bColor;
	asm push ds;
	asm lds si,pBitmap;
	asm mov cx,[ds:si];
	asm push cx;
	asm mov dx,[ds:si + 2];
	asm lds si,dword ptr [ds:si + 4];
	asm cld;

NEXT_2:
	asm lodsb;
	asm mov ah,8;
LOOPING:
	asm rol al,1;
	asm jnc NODRAW;
DRAW:
	asm mov [es:di],bl;
NODRAW:
	asm inc di;
	asm dec ah;
	asm jnz LOOPING;
	asm loop NEXT_2;
	asm add di,320;
	asm pop cx;
	asm push cx;
	asm shl cx,3;
	asm sub di,cx;
	asm shr cx,3;
	asm dec dx;
	asm jnz NEXT_2;
	asm pop cx;
	asm pop ds;
}


void MonoBitmapOr(PBITMAP pBitmap,
						PBMPOUTINFO pBmpOutInfo,BYTE bColor)
{
	asm les di,pBmpOutInfo;
	asm mov ax,word ptr [es:di + 2];
	asm mov dx,320;
	asm mul dx;
	asm add ax,word ptr [es:di];
	asm les di,libVirScreen;
	asm add di,ax;
	asm mov bl,bColor;
	asm push ds;
	asm lds si,pBitmap;
	asm mov cx,[ds:si];
	asm push cx;
	asm mov dx,[ds:si + 2];
	asm lds si,dword ptr [ds:si + 4];
	asm cld;

NEXT_2:
	asm lodsb;
	asm mov ah,8;
LOOPING:
	asm rol al,1;
	asm jnc NODRAW;
DRAW:
	asm mov bh,[es:di];
	asm or bh,bl;
	asm mov [es:di],bh;
NODRAW:
	asm inc di;
	asm dec ah;
	asm jnz LOOPING;
	asm loop NEXT_2;
	asm add di,320;
	asm pop cx;
	asm push cx;
	asm shl cx,3;
	asm sub di,cx;
	asm shr cx,3;
	asm dec dx;
	asm jnz NEXT_2;
	asm pop cx;
	asm pop ds;
}


void MonoBitmapXor(PBITMAP pBitmap,
						PBMPOUTINFO pBmpOutInfo,BYTE bColor)
{
	asm les di,pBmpOutInfo;
	asm mov ax,word ptr [es:di + 2];
	asm mov dx,320;
	asm mul dx;
	asm add ax,word ptr [es:di];
	asm les di,libVirScreen;
	asm add di,ax;
	asm mov bl,bColor;
	asm push ds;
	asm lds si,pBitmap;
	asm mov cx,[ds:si];
	asm push cx;
	asm mov dx,[ds:si + 2];
	asm lds si,dword ptr [ds:si + 4];
	asm cld;

NEXT_2:
	asm lodsb;
	asm mov ah,8;
LOOPING:
	asm rol al,1;
	asm jnc NODRAW;
DRAW:
	asm mov bh,[es:di];
	asm xor bh,bl;
	asm mov [es:di],bh;
NODRAW:
	asm inc di;
	asm dec ah;
	asm jnz LOOPING;
	asm loop NEXT_2;
	asm add di,320;
	asm pop cx;
	asm push cx;
	asm shl cx,3;
	asm sub di,cx;
	asm shr cx,3;
	asm dec dx;
	asm jnz NEXT_2;
	asm pop cx;
	asm pop ds;
}


void MonoBitmapAnd(PBITMAP pBitmap,
						PBMPOUTINFO pBmpOutInfo,BYTE bColor)
{
	asm les di,pBmpOutInfo;
	asm mov ax,word ptr [es:di + 2];
	asm mov dx,320;
	asm mul dx;
	asm add ax,word ptr [es:di];
	asm les di,libVirScreen;
	asm add di,ax;
	asm mov bl,bColor;
	asm push ds;
	asm lds si,pBitmap;
	asm mov cx,[ds:si];
	asm push cx;
	asm mov dx,[ds:si + 2];
	asm lds si,dword ptr [ds:si + 4];
	asm cld;

NEXT_2:
	asm lodsb;
	asm mov ah,8;
LOOPING:
	asm rol al,1;
	asm jnc NODRAW;
DRAW:
	asm mov bh,[es:di];
	asm and bh,bl;
	asm mov [es:di],bh;
NODRAW:
	asm inc di;
	asm dec ah;
	asm jnz LOOPING;
	asm loop NEXT_2;
	asm add di,320;
	asm pop cx;
	asm push cx;
	asm shl cx,3;
	asm sub di,cx;
	asm shr cx,3;
	asm dec dx;
	asm jnz NEXT_2;
	asm pop cx;
	asm pop ds;
}
